<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="xml"/>
    <xsl:param name="subrequests"/>
    
	<xsl:variable name="trace-view">/visualizer</xsl:variable>
	<xsl:variable name="trace-raw">/visualizer</xsl:variable>
	<xsl:variable name="imgbase">/nkse/style/img/</xsl:variable>
	<xsl:variable name="explorer">/tools/explore/</xsl:variable>

	 <xsl:include href="res:/nkse/style/xsl/format_resolution.xsl"/>	

	<xsl:template match="/detail" xmlns:xrl="http://netkernel.org/xrl">
		
		<xsl:variable name="fromCache" select="not(trace/endpointToString)"/>
		
		<div>
		
		<xrl:include>
			<xrl:identifier>active:aeMenu</xrl:identifier>
			<xrl:argument name="breadcrumbs">
				<breadcrumbs>
					<crumb name="Visualizer" view="visualizer"/>
					<crumb name="{root}" type="trace" entity="{hash}"/>
					<crumb type="request" entity="{hash}/{requestIndex}">
						<xsl:choose>
							<xsl:when test="trace/rfe">
								<xsl:attribute name="name">[none]</xsl:attribute>
							</xsl:when>
							<xsl:when test="trace/cached">
								<xsl:attribute name="name">[from cache]</xsl:attribute>
							</xsl:when>
							<xsl:when test="trace/internalDependency">
								<xsl:attribute name="name">[internal dependency]</xsl:attribute>
							</xsl:when>
							<xsl:otherwise>
								<xsl:attribute name="name"><xsl:value-of select="trace/endpointShort"/></xsl:attribute>
							</xsl:otherwise>
						</xsl:choose>
					</crumb>
				</breadcrumbs>
			</xrl:argument>
		</xrl:include>
						
		<script language="Javascript">
			<xsl:comment>
			
			$(document).ready(function()
			{	initLinksRaw('.el-trace','gMenuTrace');
				initLinksRaw('.el-request','gMenuRequest');
				initLinksRaw('.el-space','gMenuSpace');
				initLinksRaw('.el-rep','gMenuRep');
				initLinksRaw('.el-physical','gMenuPhysical');
				initLinksRaw('.el-ep','gMenuEp');
			});
			
			
			
				function getNamedChild(node,childName)
				{	if (node)
					{	for(child=node.firstChild; child; child=child.nextSibling )
						{	//console.log(child.nodeName);
							if (child.nodeType==1 &amp;&amp; child.nodeName==childName)
							{	return child;
							}
						}
					}
				}
				
				function fold(id)
				{ div=document.getElementById(id);
				  expand=div.style.display=='none';
				  //img=getNamedChild(getNamedChild(getNamedChild(getNamedChild(tr,"TD"),"DIV"),"A"),"IMG");
				  p = div.parentNode;
				  img = getNamedChild(getNamedChild(getNamedChild(p,"DIV"),"A"),"IMG");
				  //img = div.parentNode;
				  //alert(img);
				
				  if (expand)
				  { img.src="<xsl:value-of select="$imgbase"/>minus.png";
				    div.style.display="";
				  }
				  else
				  { img.src="<xsl:value-of select="$imgbase"/>plus.png";
				    div.style.display="none";
				  }
				}
				
			</xsl:comment>
		</script>
				<!--
				<div >
					<input type="button" value="back" onclick="parent.location='{$trace-view}/{/detail/hash}'" class="btn"/>
					<input type="button" value="view response" onclick="parent.location='{$trace-raw}/{/detail/hash}/response/{/detail/requestIndex}'" class="btn"/>
					<input type="button" value="all traces" onclick="parent.location='{$trace-view}/'" class="btn"/>
				</div>
				-->
				
				<table class="data-table" style="clear: both;">
				<tr class="vis-title">
					<td colspan="2">Request</td>
				</tr>
				<tr>
					<td class="label">Requestor:</td>
					<td>
						<xsl:choose>
							<xsl:when test="parentRequestIndex">
								<a class="el el-request" entity="{/detail/hash}/{parentRequestIndex}">
									<span class="ui-icon-ae ui-icon-ae-request"><xsl:text> </xsl:text></span>
									<xsl:value-of select="parentEndpoint"/>
								</a>
							</xsl:when>
							<xsl:otherwise>
								<span class="ui-icon-ae ui-icon-ae-request"><xsl:text> </xsl:text></span>
								<xsl:value-of select="parentEndpoint"/>
							</xsl:otherwise>
						</xsl:choose>
					</td>
				</tr>
	          <tr>
	            <td class="label">Mode:</td>
	            <td>
	            	<xsl:choose>
	            		<xsl:when test="trace/async='true'">Asynchronous</xsl:when>
	            		<xsl:otherwise>Synchronous</xsl:otherwise>
	            	</xsl:choose>
	            </td>
	          </tr>
	          <tr>
	            <td class="label">Verb:</td>
	            <td><xsl:value-of select="trace/verb"/></td>
	          </tr>
				<tr>
					<td class="label">Identifier:</td>
					<td><xsl:value-of select="trace/identifier"/></td>
				</tr>
				<tr>
					<td class="label">Request Scope:</td>
					<td>
						<table>
						<xsl:for-each select="trace/reqctx/level">
							<xsl:variable name="class">
								<xsl:choose>
									<xsl:when test="position() mod 2 = 0">
										<xsl:text>evenrow</xsl:text>
									</xsl:when>
									<xsl:otherwise>
										<xsl:text>oddrow</xsl:text>
									</xsl:otherwise>  
								</xsl:choose>
							</xsl:variable>							
							<tr><td class="{$class}">
								<xsl:choose>
									<xsl:when test="hash">
										<a class="el el-space" entity="{hash}">
											<span class="ui-icon-ae ui-icon-ae-scope">
											<xsl:if test="position()=last()"><xsl:attribute name="class">ui-icon-ae ui-icon-ae-space</xsl:attribute></xsl:if>
											<xsl:text> </xsl:text></span>
											<xsl:value-of select="space"/>
										</a>
									</xsl:when>
									<xsl:otherwise>
										<span class="ui-icon-ae ui-icon-ae-scope">
										<xsl:if test="position()=last()"><xsl:attribute name="class">ui-icon-ae ui-icon-ae-space</xsl:attribute></xsl:if>
										<xsl:text> </xsl:text></span>
										<xsl:value-of select="space"/>
									</xsl:otherwise>
								</xsl:choose>
							</td></tr>
						</xsl:for-each>																				
						</table>
					</td>
				</tr>
				<xsl:if test="trace/primary">
				<tr>
					<td class="label">Primary Arg:</td>
					<td>
					
						<xsl:choose>
							<xsl:when test="trace/primary/pN">
								<a class="el el-rep" entity="{trace/primary/pH}">
									<span class="ui-icon-ae ui-icon-ae-rep"><xsl:text> </xsl:text></span>
									<xsl:value-of select="trace/primary/pN"/>
								</a>
								(<xsl:value-of select="trace/primary/pC"/>)
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="trace/primary/pC"/>
							</xsl:otherwise>
						</xsl:choose>					
						<div>
							<input type="button" value="view" onclick="doMenu('visPrimary','{/detail/hash}/{/detail/requestIndex}')" class="btn"/>
						</div>
					</td>
				</tr>
				</xsl:if>
				<tr>
					<td class="label">Requested Rep:</td>
					<td>
						<xsl:choose>
							<xsl:when test="trace/rrN">
								<a class="el el-rep" entity="{trace/rrH}">
									<span class="ui-icon-ae ui-icon-ae-rep"><xsl:text> </xsl:text></span>
									<xsl:value-of select="trace/rrN"/>
								</a>
								(<xsl:value-of select="trace/rrC"/>)
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="trace/rrC"/>
							</xsl:otherwise>
						</xsl:choose>					
					</td>
				</tr>
				
				
				
				
				<tr>
					<td class="label">Priority:</td>
					<td><xsl:value-of select="trace/priority"/></td>
				</tr>
				<tr><td class="label">Headers:</td><td>
					<xsl:choose>
						<xsl:when test="trace/headers/value">
							<xsl:for-each select="trace/headers/value">
								<xsl:variable name="class">
									<xsl:choose>
										<xsl:when test="position() mod 2 = 0">
											<xsl:text>evenrow</xsl:text>
										</xsl:when>
										<xsl:otherwise>
											<xsl:text>oddrow</xsl:text>
										</xsl:otherwise>  
									</xsl:choose>
								</xsl:variable>							
								<div class="{$class}">
									<xsl:value-of select="@key"/> = <xsl:value-of select="."/>
								</div>
							</xsl:for-each>
						</xsl:when>
						<xsl:otherwise>[none]</xsl:otherwise>
					</xsl:choose>
				</td></tr>
				
				<tr class="vis-title">
					<td colspan="2">Resolution</td>
				</tr>
				<tr>
					<td class="label">Resolution Trace:</td>
					<td>
						<xsl:choose>
							<xsl:when test="resolve/trace/n">
								<xsl:for-each select="resolve/trace">
									<xsl:call-template name="resolution"/>
								</xsl:for-each>
							</xsl:when>
							<xsl:otherwise>
								<b>Resolution not available.</b><br/>
								- have modules been recommissioned since trace captured?
							</xsl:otherwise>
						</xsl:choose>
					</td>
				</tr>
				<tr>
					<td class="label">Physical Endpoint:</td>
					<td>
						<xsl:choose>
							<xsl:when test="trace/rfe"><span class="ui-icon-ae ui-icon-ae-rfe"><xsl:text> </xsl:text></span>[none]
							</xsl:when>
							<xsl:when test="trace/cached"><span class="ui-icon-ae ui-icon-ae-cached"><xsl:text> </xsl:text></span>[from cache]
							</xsl:when>
							<xsl:when test="trace/internalDependency"><span class="ui-icon-ae ui-icon-ae-cached"><xsl:text> </xsl:text></span>[internal dependency]
							</xsl:when>
							<xsl:when test="trace/endpointHash">
								<a class="el el-physical" entity="{trace/endpointHash}">
									<span class="ui-icon-ae ui-icon-ae-physical"><xsl:text> </xsl:text></span>
									<xsl:value-of select="trace/endpointToString"/>
								</a>
							</xsl:when>
							<xsl:when test="trace/endpointToString">
								<span class="ui-icon-ae ui-icon-ae-physical"><xsl:text> </xsl:text></span>
								<xsl:value-of select="trace/endpointToString"/>
							</xsl:when>
						</xsl:choose>	
					</td>
				</tr>
				
				<tr>
					<td class="label">Logical Endpoint:</td>
					<td>
						<xsl:choose>
							<xsl:when test="trace/logicalHash">
								<a class="el el-ep" entity="{trace/logicalHash}">
									<span class="ui-icon-ae ui-icon-ae-ep"><xsl:text> </xsl:text></span>
									<xsl:value-of select="trace/logicalEndpoint"/>
								</a>
							</xsl:when>
							<xsl:when test="trace/logicalEndpoint">
								<span class="ui-icon-ae ui-icon-ae-ep"><xsl:text> </xsl:text></span>
								<xsl:value-of select="trace/logicalEndpoint"/>
							</xsl:when>
							<xsl:otherwise>
								[unknown]
							</xsl:otherwise>
						</xsl:choose>
					</td>
				</tr>
				<tr>
					<td class="label">Evaluation Scope:</td>
					<td>
						<xsl:choose>
							<xsl:when test="trace/endpoint">
								<table>
								<xsl:for-each select="trace/resctx/level">
									<xsl:variable name="class">
										<xsl:choose>
											<xsl:when test="position() mod 2 = 0">
												<xsl:text>evenrow</xsl:text>
											</xsl:when>
											<xsl:otherwise>
												<xsl:text>oddrow</xsl:text>
											</xsl:otherwise>  
										</xsl:choose>
									</xsl:variable>							
									<tr><td class="{$class}">
										<xsl:choose>
											<xsl:when test="hash">
												<a class="el el-space" entity="{hash}">
													<span class="ui-icon-ae ui-icon-ae-scope">
													<xsl:if test="position()=last()"><xsl:attribute name="class">ui-icon-ae ui-icon-ae-space</xsl:attribute></xsl:if>
													<xsl:text> </xsl:text></span>
													<xsl:value-of select="space"/>
												</a>
											</xsl:when>
											<xsl:otherwise>
												<span class="ui-icon-ae ui-icon-ae-scope">
												<xsl:if test="position()=last()"><xsl:attribute name="class">ui-icon-ae ui-icon-ae-space</xsl:attribute></xsl:if>
												<xsl:text> </xsl:text></span>
												<xsl:value-of select="space"/>
											</xsl:otherwise>
										</xsl:choose>
									</td></tr>
								</xsl:for-each>
								</table>																											
							</xsl:when>
							<xsl:otherwise>[unknown]</xsl:otherwise>
						</xsl:choose>
					</td>
				</tr>
				
				<xsl:if test="trace/endpoint">
				<tr class="vis-title">
					<td colspan="2">Endpoint Execution</td>
				</tr>
				<tr>
					<td class="label">Endpoint Class:</td>
					<td>
						<xsl:value-of select="trace/endpoint"/>
					</td>
				</tr>
				<tr>
					<td class="label">Endpoint Space:</td>
					<td>
						<xsl:choose>
							<xsl:when test="trace/endpointHomeHash">
								<a class="el el-space" entity="{trace/endpointHomeHash}">
									<span class="ui-icon-ae ui-icon-ae-space"><xsl:text> </xsl:text></span>
									<xsl:value-of select="trace/endpointHomeContext"/>
								</a>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="trace/endpointHomeContext"/>
							</xsl:otherwise>
						</xsl:choose>
					</td>
				</tr>
				<tr>
					<td class="label">Subrequests:</td>
					<td>
						<xsl:copy-of select="$subrequests"/>
					</td>
				</tr>
				</xsl:if>
				<tr class="vis-title">
					<td>Response
					</td>
					<td>
					</td>
				</tr>
				<tr>
					<td class="label">Representation:</td>
					<td>
						<xsl:if test="trace/responseException='true'">
							<xsl:attribute name="class">error</xsl:attribute>
						</xsl:if>
						<xsl:choose>
							<xsl:when test="trace/responseName">
								<a class="el el-rep" entity="{trace/responseHash}">
									<span class="ui-icon-ae ui-icon-ae-rep"><xsl:text> </xsl:text></span>
									<xsl:value-of select="trace/responseName"/>
								</a>
								(<xsl:value-of select="trace/responseClass"/>)
							</xsl:when>
							<xsl:otherwise>
								<span class="ui-icon-ae ui-icon-ae-rep"><xsl:text> </xsl:text></span>
								<xsl:value-of select="trace/responseClass"/>
							</xsl:otherwise>
						</xsl:choose>
						<div>
							<input type="button" value="view" onclick="doMenu('visResp','{/detail/hash}/{/detail/requestIndex}')" class="btn"/>
						</div>
					</td>
				</tr>
				<tr><td class="label">Headers:</td><td>
					<xsl:choose>
						<xsl:when test="trace/usermeta/value">
							<xsl:for-each select="trace/usermeta/value">
								<xsl:variable name="class">
									<xsl:choose>
										<xsl:when test="position() mod 2 = 0">
											<xsl:text>evenrow</xsl:text>
										</xsl:when>
										<xsl:otherwise>
											<xsl:text>oddrow</xsl:text>
										</xsl:otherwise>  
									</xsl:choose>
								</xsl:variable>							
								<div class="{$class}">
									<xsl:value-of select="@key"/> = <xsl:value-of select="."/>
								</div>
							</xsl:for-each>
						</xsl:when>
						<xsl:otherwise>[none]</xsl:otherwise>
					</xsl:choose>
				</td></tr>
				<tr><td class="label">Expiry:</td><td>
					<xsl:for-each select="trace/expiry/e">
						<xsl:call-template name="expiry"/>
					</xsl:for-each>
				</td></tr>
				<tr><td class="label">isExpired?:</td><td>
					<span style="padding: 0 1em 0 1em; color: white; font-weight:bold;">
					<xsl:choose>
						<xsl:when test="trace/isExpired='true'">
							<xsl:attribute name="class">expired</xsl:attribute>
							true
						</xsl:when>
						<xsl:when test="trace/isExpired='false'">
							<xsl:attribute name="class">valid</xsl:attribute>
							false
						</xsl:when>
						<xsl:otherwise>
							<xsl:attribute name="class">unknownExpiry</xsl:attribute>
							[unknown]
						</xsl:otherwise>
					</xsl:choose>
					</span>			
				</td></tr>
				<tr><td class="label">Cost:</td><td>
					<xsl:choose>
						<xsl:when test="trace/cost"><xsl:value-of select="trace/cost"/> of which <xsl:value-of select="trace/costl"/> is local</xsl:when>
						<xsl:otherwise>[unknown]</xsl:otherwise>
					</xsl:choose>
				</td></tr>
				
				<tr><td class="label">isCachable?:</td><td>
					<span style="padding: 0 1em 0 1em; color: white; font-weight:bold;">
					<xsl:choose>
						<xsl:when test="trace/isCachable='true'">
							<xsl:attribute name="class">valid</xsl:attribute>true</xsl:when>
						<xsl:when test="trace/isCachable='false'">
							<xsl:attribute name="class">expired</xsl:attribute>false</xsl:when>
						<xsl:when test="trace/isCachable='maybe'">
							<xsl:attribute name="style">background: #D0B000; padding: 0 1em 0 1em; color: black; font-weight:bold;</xsl:attribute>maybe</xsl:when>
					</xsl:choose>			
					</span>
					<xsl:text> </xsl:text>
					<xsl:value-of select="trace/cachableStatus"/>
					<xsl:if test="trace/cachableTool">
						<div><input type="button" value="details" onclick="doMenu('{trace/cachableTool}','{/detail/hash}/{/detail/requestIndex}')" class="btn"/></div>
					</xsl:if>
				</td></tr>
				
				
				<tr><td class="label">Response Scope:
					</td>
					<td id="response-scope">
						(yellow area indicates scope used in processing request)
						
						<xsl:choose>
							<xsl:when test="trace/scope">
								<xsl:variable name="scope"><xsl:value-of select="trace/scope"/></xsl:variable>
								<table>
									<xsl:for-each select="trace/reqctx/level">
									<xsl:variable name="class">
										<xsl:choose>
											<xsl:when test="$scope+1 >= position() and position() mod 2 = 0">
												<xsl:text>evenrowScope</xsl:text>
											</xsl:when>
											<xsl:when test="$scope+1 >= position()">
												<xsl:text>oddrowScope</xsl:text>
											</xsl:when>
											<xsl:when test="position() mod 2 = 0">
												<xsl:text>evenrow</xsl:text>
											</xsl:when>
											<xsl:otherwise>
												<xsl:text>oddrow</xsl:text>
											</xsl:otherwise>  
										</xsl:choose>
									</xsl:variable>							
									<tr ><td class="{$class}">
										<span class="ui-icon-ae ui-icon-ae-scope">
										<xsl:if test="position()=last()"><xsl:attribute name="class">ui-icon-ae ui-icon-ae-space</xsl:attribute></xsl:if>
										<xsl:text> </xsl:text></span>
										<xsl:value-of select="space"/>
									</td></tr>
								</xsl:for-each>
								</table>
							</xsl:when>
							<xsl:otherwise><br/>[unknown]
							</xsl:otherwise>																			
						</xsl:choose>
						
					</td>
				</tr>
					

			</table>

		</div>		
	</xsl:template>
	
	<xsl:template name="expiry">
		<div>
			<xsl:value-of select="@msg"/>
			<xsl:if test="e">
				<div style="margin-left: 1em;">
				<xsl:for-each select="e">
					<xsl:call-template name="expiry"/>
				</xsl:for-each>
				</div>
			</xsl:if>
		</div>
	</xsl:template>		
	
</xsl:stylesheet>
